
// RTxMGCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RTxMGC.h"
#include "RTxMGCDlg.h"
#include "SDL.h"
#include <stdio.h>
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define GRAB 1
#define FREEZEON 2
#define FREEZEOFF 4

const UINT    wm_MessageFG =
RegisterWindowMessage(_T("ZenCS-UK-NDI-RTX-FG"));


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CRTxMGCDlg dialog



CRTxMGCDlg::CRTxMGCDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_RTXMGC_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRTxMGCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CRTxMGCDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_G1, OnBnClickedButtonG1)
	ON_BN_CLICKED(IDC_BUTTON_G2, OnBnClickedButtonG2)
	ON_BN_CLICKED(IDC_BUTTON_G3, OnBnClickedButtonG3)
	ON_BN_CLICKED(IDC_BUTTON_G4, OnBnClickedButtonG4)
	ON_BN_CLICKED(IDC_BUTTON_ALL, OnBnClickedButtonAll)
	ON_BN_CLICKED(IDC_BUTTON_GP, OnBnClickedButtonGp)
	ON_BN_CLICKED(IDC_BUTTON_FREEZE, OnBnClickedButtonFreeze)
END_MESSAGE_MAP()


// CRTxMGCDlg message handlers

BOOL CRTxMGCDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRTxMGCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRTxMGCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRTxMGCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL CRTxMGCDlg::PreTranslateMessage(MSG* pMsg)
{
	if ((pMsg->message == WM_KEYDOWN))
	{
		if (pMsg->wParam == VK_RETURN)
		{
			pMsg->wParam = VK_TAB;
			return __super::PreTranslateMessage(pMsg);
			//return TRUE;
		}
	}
	
	return __super::PreTranslateMessage(pMsg);
}

void CRTxMGCDlg::OnTimer(UINT_PTR uID)
{
	DWORD temp_num;
	WORD bstate, bit = 1;

	switch (uID)
	{

	case 1:
		loop++;

		if (!ButtonRefresh())
		{
			KillTimer(1);
			SetDlgItemText(IDC_BUTTON_GP, L"Find gamepad");
		}
		else
		{
			temp_num = XBox_state.dwPacketNumber;
			if (packet_num < temp_num)
			{
				bstate = XBox_state.Gamepad.wButtons;

				for (int ix = 0; ix < 16; ix++)
				{
					if (bstate & bit)
					{ 
						if (!timeout[ix] && (!buttons[ix]))
						{
							XBoxButtonPressed(ix);
							buttons[ix] = 1;
							timeout[ix] = 18;
						}
					}
					else
					{
						buttons[ix] = 0;
					}
					bit = bit << 1;
				}
				packet_num = temp_num;
			}
			for (int ix = 0; ix < 16; ix++)
			{
				if (timeout[ix])
					timeout[ix]--;
			}
		}
		break;
	default:
		break;
	}
}

void CRTxMGCDlg::XBoxButtonPressed(int bnum)
{
	switch (bnum)
	{
	case 12:  // XINPUT_GAMEPAD_A
		::PostMessage(HWND_BROADCAST, wm_MessageFG, 1, GRAB); // Grab from RTx 1
		break;
	case 13:  // XINPUT_GAMEPAD_B
		::PostMessage(HWND_BROADCAST, wm_MessageFG, 2, GRAB); // Grab from RTx 2
		break;
	case 14:  // XINPUT_GAMEPAD_X
		OnBnClickedButtonFreeze();
		break;
	case 15:  // XINPUT_GAMEPAD_Y
		::PostMessage(HWND_BROADCAST, wm_MessageFG, 0, GRAB); // Grab from all instances of RTx
		break;

	case 0:   // XINPUT_GAMEPAD_DPAD_UP
	case 1:   // XINPUT_GAMEPAD_DPAD_DOWN
	case 2:   // XINPUT_GAMEPAD_DPAD_LEFT
	case 3:   // XINPUT_GAMEPAD_DPAD_RIGHT

	case 4:   // XINPUT_GAMEPAD_START
	case 5:   // XINPUT_GAMEPAD_BACK
	case 6:   // XINPUT_GAMEPAD_LEFT_THUMB
	case 7:   // XINPUT_GAMEPAD_RIGHT_THUMB

	case 8:   // XINPUT_GAMEPAD_LEFT_SHOULDER
	case 9:   // XINPUT_GAMEPAD_RIGHT_SHOULDER
	
	default:
		break;
	}
}

void CRTxMGCDlg::OnBnClickedButtonGp()
{
	// TODO: Add your control notification handler code here

	if (ButtonRefresh())
	{
		str0.Format(_T("Gamepad found"));
		SetDlgItemText(IDC_BUTTON_GP, str0);

		SetTimer(1, 10, 0);
	}
}

void CRTxMGCDlg::OnBnClickedButtonAll()
{
	// TODO: Add your control notification handler code here
	::PostMessage(HWND_BROADCAST, wm_MessageFG, 0, GRAB);
}

void CRTxMGCDlg::OnBnClickedButtonFreeze()
{
	// TODO: Add your control notification handler code here

	if (Freeze)
	{
		Freeze = 0;
		::PostMessage(HWND_BROADCAST, wm_MessageFG, 0, FREEZEOFF);
		SetDlgItemText(IDC_BUTTON_FREEZE, L"Freeze All");
	}
	else
	{
		Freeze = 1;
		::PostMessage(HWND_BROADCAST, wm_MessageFG, 0, FREEZEON);
		SetDlgItemText(IDC_BUTTON_FREEZE, L"Un-freeze All");
	}
}

void CRTxMGCDlg::OnBnClickedButtonG1()
{
	// TODO: Add your control notification handler code here
	::PostMessage(HWND_BROADCAST, wm_MessageFG, 1, GRAB);
}

void CRTxMGCDlg::OnBnClickedButtonG2()
{
	// TODO: Add your control notification handler code here
	::PostMessage(HWND_BROADCAST, wm_MessageFG, 2, GRAB);
}

void CRTxMGCDlg::OnBnClickedButtonG3()
{
	// TODO: Add your control notification handler code here
	::PostMessage(HWND_BROADCAST, wm_MessageFG, 3, GRAB);
}

void CRTxMGCDlg::OnBnClickedButtonG4()
{
	// TODO: Add your control notification handler code here
	::PostMessage(HWND_BROADCAST, wm_MessageFG, 4, GRAB);
}


bool CRTxMGCDlg::CheckConnection()
{
	int controllerId = -1;

	// Check each port for a connection until one is found
	for (DWORD i = 0; i < XUSER_MAX_COUNT && controllerId == -1; i++)
	{
		XINPUT_STATE state;
		ZeroMemory(&state, sizeof(XINPUT_STATE));

		if (XInputGetState(i, &state) == ERROR_SUCCESS)
			controllerId = i;
	}

	gpadId = controllerId;

	return controllerId != -1;
}

// Returns false if the controller has been disconnected
bool CRTxMGCDlg::ButtonRefresh()
{
	// Try to establish a connection with the controller if none was connected last time
	if (gpadId == -1)
		CheckConnection();

	// If the controller is connected...
	if (gpadId != -1)
	{

		// Check state and check for disconnection
		ZeroMemory(&XBox_state, sizeof(XINPUT_STATE));
		if (XInputGetState(gpadId, &XBox_state) != ERROR_SUCCESS)
		{
			gpadId = -1;
			return false;
		}
		return true;
	}
	return false;
}

